﻿local	tiLevel_debug = false;
local	tiLevel_showItemCalc = false;
local	tiLevel_debugStatWeight = false;

statModifiers = {

    -- Most commonly used stats
    ITEM_MOD_STAMINA =               (2/3),
    ITEM_MOD_STAMINA_SHORT =         (2/3),
    ITEM_MOD_STRENGTH =              1,
    ITEM_MOD_STRENGTH_SHORT =        1,
    ITEM_MOD_AGILITY =               1,
    ITEM_MOD_AGILITY_SHORT =         1,
    ITEM_MOD_INTELLECT =             1,
    ITEM_MOD_INTELLECT_SHORT =       1,
    ITEM_MOD_SPIRIT =                1,
    ITEM_MOD_SPIRIT_SHORT =          1,
    ITEM_MOD_ATTACK_POWER =          (1/2),
    ITEM_MOD_ATTACK_POWER_SHORT =    (1/2),
    ITEM_MOD_FERAL_ATTACK_POWER =    (1/2),
    ITEM_MOD_FERAL_ATTACK_POWER_SHORT =(1/2),
    ITEM_MOD_SPELL_POWER =           (6/7),
    ITEM_MOD_SPELL_POWER_SHORT =     (6/7),
    ITEM_MOD_BLOCK_RATING =          (13/40),  -- Assuming block value and rating hold
    ITEM_MOD_BLOCK_RATING_SHORT =    (13/40),  -- the same weight.
    ITEM_MOD_BLOCK_VALUE =           (13/40),
    ITEM_MOD_BLOCK_VALUE_SHORT =     (13/40),
    
    -- Regen values
    ITEM_MOD_POWER_REGEN0_SHORT =    (5/2),    -- MP5
    ITEM_MOD_POWER_REGEN1_SHORT =    (5/2),    -- Rage per 5
    ITEM_MOD_POWER_REGEN2_SHORT =    (5/2),    -- Focus per 5
    ITEM_MOD_POWER_REGEN3_SHORT =    (5/2),    -- Energy per 5
    ITEM_MOD_POWER_REGEN4_SHORT =    (5/2),    -- Happiness per 5
    ITEM_MOD_POWER_REGEN5_SHORT =    (5/2),    -- Runes per 5
    ITEM_MOD_POWER_REGEN6_SHORT =    (5/2),    -- Runic power per 5
    
    -- Stats with rating values (all currently share the same weight)
    ITEM_MOD_ARMOR_PENETRATION_RATING =          1,
    ITEM_MOD_ARMOR_PENETRATION_RATING_SHORT =    1,
    ITEM_MOD_CRIT_MELEE_RATING =                 1,
    ITEM_MOD_CRIT_MELEE_RATING_SHORT =           1,
    ITEM_MOD_CRIT_RANGED_RATING =                1,
    ITEM_MOD_CRIT_RANGED_RATING_SHORT =          1,
    ITEM_MOD_CRIT_RATING =                       1,
    ITEM_MOD_CRIT_RATING_SHORT =                 1,
    ITEM_MOD_CRIT_SPELL_RATING =                 1,
    ITEM_MOD_CRIT_SPELL_RATING_SHORT =           1,
    ITEM_MOD_CRIT_TAKEN_MELEE_RATING =           1,
    ITEM_MOD_CRIT_TAKEN_MELEE_RATING_SHORT =     1,
    ITEM_MOD_CRIT_TAKEN_RANGED_RATING =          1,
    ITEM_MOD_CRIT_TAKEN_RANGED_RATING_SHORT =    1,
    ITEM_MOD_CRIT_TAKEN_RATING =                 1,
    ITEM_MOD_CRIT_TAKEN_RATING_SHORT =           1,
    ITEM_MOD_CRIT_TAKEN_SPELL_RATING =           1,
    ITEM_MOD_CRIT_TAKEN_SPELL_RATING_SHORT =     1,
    ITEM_MOD_DEFENSE_SKILL_RATING =              1,
    ITEM_MOD_DEFENSE_SKILL_RATING_SHORT =        1,
    ITEM_MOD_DODGE_RATING =						 1,
    ITEM_MOD_DODGE_RATING_SHORT =				 1,
    ITEM_MOD_EXPERTISE_RATING =                  1,
    ITEM_MOD_EXPERTISE_RATING_SHORT =            1,
    ITEM_MOD_HASTE_MELEE_RATING =                1,
    ITEM_MOD_HASTE_MELEE_RATING_SHORT =          1,
    ITEM_MOD_HASTE_RANGED_RATING =               1,
    ITEM_MOD_HASTE_RANGED_RATING_SHORT =         1,
    ITEM_MOD_HASTE_RATING =                      1,
    ITEM_MOD_HASTE_RATING_SHORT =                1,
    ITEM_MOD_HASTE_SPELL_RATING =                1,
    ITEM_MOD_HASTE_SPELL_RATING_SHORT =          1,
    ITEM_MOD_HIT_MELEE_RATING =                  1,
    ITEM_MOD_HIT_MELEE_RATING_SHORT =            1,
    ITEM_MOD_HIT_RANGED_RATING =                 1,
    ITEM_MOD_HIT_RANGED_RATING_SHORT =           1,
    ITEM_MOD_HIT_RATING =                        1,
    ITEM_MOD_HIT_RATING_SHORT =                  1,
    ITEM_MOD_HIT_SPELL_RATING =                  1,
    ITEM_MOD_HIT_TAKEN_MELEE_RATING =            1,
    ITEM_MOD_HIT_TAKEN_MELEE_RATING_SHORT =      1,
    ITEM_MOD_HIT_TAKEN_RANGED_RATING =           1,
    ITEM_MOD_HIT_TAKEN_RANGED_RATING_SHORT =     1,
    ITEM_MOD_HIT_TAKEN_RATING =                  1,
    ITEM_MOD_HIT_TAKEN_RATING_SHORT =            1,
    ITEM_MOD_HIT_TAKEN_SPELL_RATING =            1,
    ITEM_MOD_HIT_TAKEN_SPELL_RATING_SHORT =      1,
    ITEM_MOD_PARRY_RATING =                      1,
    ITEM_MOD_PARRY_RATING_SHORT =                1,
    ITEM_MOD_RESILIENCE_RATING =                 1,
    ITEM_MOD_RESILIENCE_RATING_SHORT =           1,
    ITEM_MOD_SPELL_PENETRATION =                 1,
    ITEM_MOD_SPELL_PENETRATION_SHORT =           1,
    
    -- Sockets: All sockets are assumed to be worth 16 points a stat's value 
    EMPTY_SOCKET_META =                          16,
    EMPTY_SOCKET =                               16,
    EMPTY_SOCKET_RED =                           16,
    EMPTY_SOCKET_BLUE =                          16,
    EMPTY_SOCKET_YELLOW =                        16,
    EMPTY_SOCKET_NO_COLOR =                      16
}

--
-- slotModifiers and their weights
--
slotModifiers = {
	INVTYPE_CHEST =				1,
	INVTYPE_ROBE =				1,
	INVTYPE_HEAD =				1,
	INVTYPE_LEGS =				1,
	INVTYPE_2HWEAPON =			1,
	INVTYPE_SHOULDER =			(3/4),
	INVTYPE_HAND =				(3/4),
	INVTYPE_WAIST =				(3/4),
	INVTYPE_FEET =				(3/4),
	INVTYPE_WRIST =				(9/16),
	INVTYPE_NECK =				(9/16),
	INVTYPE_CLOAK =				(9/16),
	INVTYPE_FINGER =			(9/16),
	INVTYPE_HOLDABLE =			(9/16),
	INVTYPE_SHIELD =			(9/16),
	INVTYPE_RANGEDRIGHT =		(5/16),
	INVTYPE_WEAPON =			(27/64),
	INVTYPE_WEAPONMAINHAND =	(27/64),
	INVTYPE_WEAPONOFFHAND =		(27/64),
	INVTYPE_TRINKET =			(17/25),	-- Due to the nature of trinkets and procs, do not expect this to work.
	INVTYPE_RANGED =			(81/256),	-- This is assuming that crossbows, bows and wands are
	INVTYPE_THROWN =			(81/256),	-- calculated equally.
}

--
-- Item rarities
-- 
ITEM_QUALITY_POOR		= 0
ITEM_QUALITY_COMMON		= 1
ITEM_QUALITY_UNCOMMON	= 2
ITEM_QUALITY_RARE		= 3
ITEM_QUALITY_EPIC		= 4
ITEM_QUALITY_LEGENDARY	= 5
ITEM_QUALITY_ARTIFACT	= 6
ITEM_QUALITY_HEIRLOOM	= 7

function AddInfoToTooltip(tip, link)
	local itemValue = 0;
	local itemSlotValue = 0;
	local trueItemLevel = 0;

    -- Get all the required information on the item that we're looking up.
    local itemName, itemLink, itemRarity, itemLevel, _, itemType, itemSubType, _, itemEquipLoc = GetItemInfo(link);
    
    -- The item must have a valid name, equip slot and must not be a trinket (not currently functional)
    if itemName == "" or itemName == nil or 
       itemEquipLoc == "" or itemEquipLoc == "INVTYPE_TRINKET" then
		if tiLevel_debug == true then
			tip:AddDoubleLine("invalid item", "", 0, .8, 1, .68, .94, 1);
			tip:Show()
		end
		return;
    end
    
    -- Calculate the item value.
    itemValue = getItemValue(itemLink, itemEquipLoc);
    if itemValue <= 0 then
		-- This tends to become very spammy when viewing lower level items that do not have
		-- stats. (eg. low level wands/guns/bows)
		--if tiLevel_debug == true then
		--	DEFAULT_CHAT_FRAME:AddMessage("Invalid item value: "..itemValue);
		--end	
		return;
    end
    
    -- Calculate the item slot value
    itemSlotValue = getItemSlotValue(itemValue, itemEquipLoc);
    if itemSlotValue <= 0 then
		if tiLevel_debug == true then
			DEFAULT_CHAT_FRAME:AddMessage("Invalid item slot value: "..itemSlotValue);
		end
		return;
    end
    
    -- Finally, calculate the true item level based on the previous values
    trueItemLevel = getTrueItemLevel(itemSlotValue, itemLevel, itemRarity);
    if trueItemLevel <= 0 then
		return;
    end
    
    -- Add the true item value to the tooltip.
	tip:AddDoubleLine(string.format("tiLevel: %.2f / %d", trueItemLevel, itemLevel), string.format("%.0f%%",(trueItemLevel/itemLevel)*100), 0, .8, 1, .68, .94, 1);
	tip:Show()
end

--
-- Tooltip hooking based on SellFish by Tuller.
--
local function IsBagSlot(slot)
	return slot >= 20 and slot <= 23 or slot >= 68
end

--
-- List of methods that provide item tooltips. (Profession tabs, bags, roll items, etc)
-- and their respective methods on returning said item for tooltip modification.
--
local hooks = {
	SetHyperlink = function(link)
		return link
	end,

	SetBagItem = function(bag, slot)
		if not MerchantFrame:IsVisible() then
			return GetContainerItemLink(bag, slot)
		end
	end,

	SetInventoryItem = function(unit, slot)
		return GetInventoryItemLink(unit, slot)
	end,

	SetLootItem = function(slot)
		if LootSlotIsItem(slot) then
			return GetLootSlotLink(slot)
		end
	end,

	SetLootRollItem = function(slot)
		return GetLootRollItemLink(slot)
	end,

	SetAuctionItem = function(type, index)
		return GetAuctionItemLink(type, index)
	end,

	SetAuctionSellItem = function()
		return select(2, GetItemInfo(GetAuctionSellItemInfo()))
	end,

	SetTradeSkillItem = function(skill, id)
		if id then
			return GetTradeSkillReagentItemLink(skill, id)
		end
		return GetTradeSkillItemLink(skill)
	end,

	SetQuestItem = function(type, index)
		return GetQuestItemLink(type, index)
	end,

	SetQuestLogItem = function(type, index)
		return GetQuestLogItemLink(type, index)
	end,

	SetTradePlayerItem = function(id)
		return GetTradePlayerItemLink(id)
	end,

	SetTradeTargetItem = function(id)
		return GetTradeTargetItemLink(id)
	end,

	SetInboxItem = function(id)
		return GetInboxItemLink(id)
	end,

	SetSendMailItem = function(id)
		return select(2, GetItemInfo(GetSendMailItem(id)))
	end,

	SetGuildBankItem = function(tab, slot)
		return GetGuildBankItemInfo(tab, slot)
	end,	
}

--
-- hookTip - Quick wrapper function to hook a function on a tooltip from a function
-- that returns a item. (see array above)
--
function hookTip(tooltip, method, action)
	hooksecurefunc(tooltip, method, function(tip, ...)
		local link = action(...)
		if link then
			AddInfoToTooltip(tip, link)
		end
	end)
end


--
-- isSpellPowerWeapon - Returns true is the item is a caster weapon, false if otherwise.
--
function isSpellPowerWeapon(stat, itemEquipLoc)

	if itemEquipLoc == "INVTYPE_WEAPON" or 
	   itemEquipLoc == "INVTYPE_2HWEAPON" or
	   itemEquipLoc == "INVTYPE_WEAPONMAINHAND" or 
	   itemEquipLoc == "INVTYPE_WEAPONOFFHAND" then
	   
	   if stat == "ITEM_MOD_SPELL_POWER" or
		  stat == "ITEM_MOD_SPELL_POWER_SHORT" then
		  -- Do nothing. Spellpower on weapons is automatically determined by their overall
		  -- item level and should not be included in the itemValue calculation.
		  return true;
	   end
	end
	
	return false;
end

--
-- getItemValue - Calculates an item's numeric value based on the stats assigned to it.
--
function getItemValue(itemLink, itemEquipLoc)
	
	local item=GetItemStats(itemLink);
	local itemValue = 0;
    
    -- Loop through each stat that the item is containing and incriment itemValue based
    -- on the weight of that stat (determined in the array, statModifiers[]).
    for stat, value in pairs(item) do 
		if statModifiers[stat] == nil then
			if tiLevel_debug == true then
				DEFAULT_CHAT_FRAME:AddMessage("DEBUG: No weight reference for stat: "..stat);
			end
		else
			if isSpellPowerWeapon(stat, itemEquipLoc) == false then
				itemValue = itemValue + (value*statModifiers[stat])^(math.log(2)/math.log(1.5));
				
				if tiLevel_showItemCalc == true then
					DEFAULT_CHAT_FRAME:AddMessage("Stat "..stat.." holds of value of "..value.." with a weight "..statModifiers[stat]);
				end
			end
		end
    end
    
    itemValue = itemValue ^ (1/(math.log(2)/math.log(1.5)));
    
    return itemValue;
end


--
-- getItemSlotValue - Calculates a item slot value based on the item slot and rarity.
--
function getItemSlotValue(itemValue, slot)
	if slotModifiers[slot] == nil then
		if tiLevel_debug == true then
			DEFAULT_CHAT_FRAME:AddMessage("ERROR getItemSlotValue(): slot ("..slot..") references a nil value.");
			return 0;
		end
	else
		return (itemValue/slotModifiers[slot]);
	end
end


--
-- getItemLevel - Calculate the true item level based on assigned item level, item slot value and rarity.
--
function getTrueItemLevel(itemSlotValue, itemLevel, itemRarity)
	
	local trueItemLevel = 0;
	
	-- Items with a item level of < 100 are considered to be vanilla WoW items and follow
	-- a linear formula.
	if itemLevel < 100 then
		if itemRarity == ITEM_QUALITY_UNCOMMON then
			trueItemLevel = 2 * itemSlotValue + 8;
		elseif itemRarity == ITEM_QUALITY_RARE then
			trueItemLevel = 1.8 * itemSlotValue + 0.75;
		elseif itemRarity == ITEM_QUALITY_EPIC then
			trueItemLevel = 1.2 * itemSlotValue + 26;
		end
	-- Items from BC and forward use a logarithmic formula for calculating raw items levels
	else
		if itemRarity == ITEM_QUALITY_UNCOMMON then
			trueItemLevel = 101.18 * math.log(itemSlotValue) - 292.23;
		elseif itemRarity == ITEM_QUALITY_RARE then
			trueItemLevel = 97.632 * math.log(itemSlotValue) - 287.14;
		elseif itemRarity == ITEM_QUALITY_EPIC then
			trueItemLevel = 106.29 * math.log(itemSlotValue) - 344.36;
		end	
	end
	
	return trueItemLevel;
end

--
-- tiLevel_CommandLineHandler - Function called when the /tilevel command is used.
--
function tiLevel_CommandLineHandler(arg)

	local itemValue = 0;
	local itemSlotValue = 0;
	local trueItemLevel = 0;

    -- Make sure a argument was entered
    if arg == "" or arg == nil then
        DEFAULT_CHAT_FRAME:AddMessage("True Item Level - by Sean \"Magichands\" White. Calculates an item's stats to determine how close it is to its item level budget.");
        DEFAULT_CHAT_FRAME:AddMessage("Usage: /tilevel <item link>");
        return;
    end
    
    -- When linking items manually, enable debug mode so the user can see 
    -- the work for calculating true item levels
    tiLevel_showItemCalc = true;

    -- Get all the required information on the item that we're looking up.
    local itemName, itemLink, itemRarity, itemLevel, _, itemType, itemSubType, _, itemEquipLoc = GetItemInfo(arg);
    
    -- Make sure that GetItemInfo returns a valid value (make sure the user enters a valid item)
    if itemName == "" or itemName == nil then
        DEFAULT_CHAT_FRAME:AddMessage("invalid item");
        return;
    end
    
    DEFAULT_CHAT_FRAME:AddMessage("Showing info for "..itemLink.." ("..itemEquipLoc..")...");
    
    -- Calculate the item value.
    itemValue = getItemValue(itemLink, itemEquipLoc);
    if tiLevel_debug == true or tiLevel_showItemCalc == true then
		DEFAULT_CHAT_FRAME:AddMessage("Item value: "..itemValue);
    end
    
    -- Calculate the item slot value
    itemSlotValue = getItemSlotValue(itemValue, itemEquipLoc);
    if tiLevel_debug == true or tiLevel_showItemCalc == true then
		DEFAULT_CHAT_FRAME:AddMessage("Item slot value: "..itemSlotValue);
    end
    
    -- Finally, calculate the true item level based on the previous values
    trueItemLevel = getTrueItemLevel(itemSlotValue, itemLevel, itemRarity);
    if tiLevel_debug == true or tiLevel_showItemCalc == true then
		DEFAULT_CHAT_FRAME:AddMessage("True item level: "..trueItemLevel);
    end
    
    -- Disable "show work mode".
    tiLevel_showItemCalc = false;
end

--
-- tiLevel_Load() - Called from the XML to execute as soon as the mod loads.
--
function    tiLevel_Load()

	-- For each of the methods in the hooks{} array, assign the tooltip hook for each
	-- of the different way to bring up tooltips in the game.
	for method,func in pairs(hooks) do
		hookTip(GameTooltip, method, func);
	end

	-- Don't forget to hook the common hyperlink.
	hookTip(ItemRefTooltip, 'SetHyperlink', hooks.SetHyperlink)

    -- Assign a function that will handle commands from the command line.
	SlashCmdList["TILEVEL"]=tiLevel_CommandLineHandler;
	
	-- Assign what slash commands that will work in invoke the command line handler function.
	SLASH_TILEVEL1="/tilevel";
	SLASH_TILEVEL2="/til";
end
